import javax.microedition.media.*;
import javax.microedition.lcdui.*;
import javax.microedition.media.control.*;
import java.util.*;

public class CameraCanvas extends Canvas implements CommandListener,  Runnable{

	private FTPMDlet mdlet;
	private Player p = null;
	private VideoControl vc = null;

	private Command cmdShot = new Command("Shot", Command.OK, 0);
	private Command cmdBack = new Command("Back", Command.BACK, 0);

	//private PreviewCanvas prev;

	private Thread th = null;

	public CameraCanvas (FTPMDlet mdlet) {
		this.mdlet = mdlet;
		addCommand(cmdShot);
		addCommand(cmdBack);
		setCommandListener(this);
		//prev=new PreviewCanvas(mdlet);
        //setFullScreenMode(true);
        try {
			p = Manager.createPlayer("capture://video");
            p.realize();
			vc = (VideoControl)p.getControl("VideoControl");
            vc.initDisplayMode(VideoControl.USE_DIRECT_VIDEO, this);
            vc.setDisplayLocation(1, 11);
            vc.setDisplaySize(getWidth()-2, 120);
            vc.setVisible(true);
            //start();
		} catch (Exception e)	 {
		}
	}

	public void start() {
		try {
			p.start();
		}catch(Exception e) {System.out.println("CameraCanvas.start():"+e);}
	}

	public void paint(Graphics g) {
		if (p.getState() == p.PREFETCHED) start();
		g.setColor(0);
		g.fillRect(0,0, getWidth(), getHeight());
		g.setColor(0xFFFFFF);
		g.drawRect(0, 10, getWidth()-1, 122);
		//g.setColor(0xFFFFFF);
		//g.drawString("X/Y:"+getWidth()+"/"+getHeight(), 10, 50, 0);

	}

	public void commandAction (Command c, Displayable d) {
		if (c == cmdBack) {
		    try {
				p.stop();
			}catch(Exception e) {System.out.println("CameraCanvas.commandAction(BACK):"+e);}
			mdlet.toMainMenu();}
		if (c == cmdShot) { (th=new Thread(this)).start(); };
	}
	
	public void run() {
		String enc=System.getProperty("video.snapshot.encodings").toLowerCase();
		
		if (enc.startsWith("encoding=")) {
        	if (enc.indexOf("jpeg")==-1) { enc="encoding=png";} else enc="encoding=jpeg";
        } else enc="jpeg";
		try {
			/* do smth with the shot! */

			Calendar c= Calendar.getInstance(); c.setTime(new Date());
			/*
            prev.setData("PICT_"+nn(c.get(c.YEAR))+"_"+
            	nn(c.get(c.MONTH))+"_"+nn(c.get(c.DATE))+".JPG", vc.getSnapshot(enc));*/
            //mdlet.bringToFront(prev);
            mdlet.view("PICT_"+nn(c.get(c.YEAR))+"_"+nn(c.get(c.MONTH))+"_"+nn(c.get(c.DATE)),
            	vc.getSnapshot(enc), PreviewCanvas.S_NEWIMAGE);
			p.stop();
		} catch(SecurityException se) {
			mdlet.messageBox("Camera error!","There is no permission to make snapshots!\nCheck aprogramm permissions");
		} catch(Exception e) {mdlet.messageBox("Camera error!", e.toString()+" Enc:"+enc);}
	}

	private String nn(int n) {
		if (n<10) { return "0"+n; } else {return ""+n;}
	}

    public void keyPressed (int keyCode) {    
    	if (getGameAction(keyCode) == FIRE) {commandAction(cmdShot, this);}
    }
}