import java.io.*;
import javax.microedition.io.*;

public class FTPData  implements Runnable{
	private FTPMDlet mdlet;
	private boolean dalive=false;
	private boolean established=false;
	private int cport=2006;
	private String cAddr;
	private DataInputStream in;
	private DataOutputStream out;
	private ByteArrayOutputStream bufferin;
	private ByteArrayOutputStream bufferout;
	private boolean terminated, tocloseconnection, toopenconnection;
	private ServerSocketConnection serv=null;
	private SocketConnection client=null;
	private FTPListener ftpl=null;

	public final static int UPLOAD = 0;
	public final static int DOWNLOAD = 1;
	private int job=1; 
	private int ftplres=0;
	private String ftplname;
	public void setJob(int j, int jj, String fname) {job = j; ftplres=jj;ftplname=fname;}
    public int getJob() {return job;}
    public int bytein=0, byteout=0;
    private Thread thisthread;

	public String getPORT() {
		return cAddr+","+cport/256+","+cport%256;
	}
	public void closeConnection() { tocloseconnection = true;}
	public void startConnection() { toopenconnection = true;}
	public void terminateThread() { thisthread=null; terminated = true; closeDataPort();}
	public void startThread() {thisthread = new Thread(this); thisthread.start(); }
	public boolean isAlive() {return (thisthread==null)?false:(thisthread.isAlive());}

	public FTPData(FTPMDlet mdlet) {
		this.mdlet = mdlet;
		bufferin = new ByteArrayOutputStream();
		bufferout = new ByteArrayOutputStream();
	}

	public void setFTPListener(FTPListener ftpl) { this.ftpl = ftpl;}
	public void removeFTPListener() {ftpl=null;}

	public boolean openDataPort() {
		if (!dalive)
    	try {    		
    		dalive=true;
            //mdlet.addLog("FTPD:Opening...");
            System.out.println("FTPD.openDataPort()...");
            serv = (ServerSocketConnection)Connector.open("socket://");
            cport = serv.getLocalPort();
            cAddr = serv.getLocalAddress();
            char[] aa = new char[cAddr.length()];
            cAddr.getChars(0, cAddr.length(), aa, 0);
            for (int i=0; i<aa.length; i++) if (aa[i]=='.') aa[i] = ',';
            cAddr = new String(aa);                        
            mdlet.addLogCommand("FTPD:"+cAddr+':'+cport);
            System.out.println("FTPD.openDataPort():Success");
            return true;
        } catch (IOException e) {
            mdlet.addLogCommand("FTPD:Opening failed:"+e);
            return false;
        }
        return false;
	
	}

	public void closeDataPort() {
		if (dalive)
		try {
			mdlet.addLogCommand("FTPD:Closing...");
			dalive = false;
			//terminated = true;
			tocloseconnection = true;
			if (in !=null) {
				in.close();
				in = null;
			}
			if (out != null) {
				out.close();
				out=null;
			}
			if (serv!=null) {
                serv.close();
				serv = null;
			} else { System.out.println("FTPD.closeDataPort(): Server is null!"); }
			mdlet.addLogCommand("FTPD:Closed.");		
		} catch(Exception e) {
			mdlet.addLogCommand("FTPD:Closing:"+e);
		}
	}

	public void run () {
		thisthread.setPriority(Thread.MIN_PRIORITY);
		//if (!dalive) openDataPort();
		mdlet.addLogCommand("FTPD:Started.");
		terminated=false;
		while (!terminated) {
			try {
				if (!openDataPort()) {System.out.println("FTPD.run():openPort failed!"); break; }
				client = (SocketConnection) serv.acceptAndOpen();
				in =  client.openDataInputStream();
				out = client.openDataOutputStream();
				mdlet.addLogCommand("FTPD:new: "+client.getAddress()+":"+client.getPort());
				System.out.println("FTPD:Connected_: "+client.getLocalAddress()+":"+client.getLocalPort());
				while (!toopenconnection) {} toopenconnection = false;
				switch(job) {
					case UPLOAD:
						byte[] dd = bufferin.toByteArray(); 
						out.write(dd, 0, dd.length);
						byteout += dd.length;
						mdlet.addLogCommand("FTPD:Uploaded "+dd.length+"b");
						out.close();
						bufferin.reset();
						if (ftpl != null) ftpl.actionComplete(ftpl.STORE, ftplname);
						break;
					case DOWNLOAD:
						try {
							bufferout.reset();
							int rd=0;
                            byte[] res = new byte[2048];
							while (!(tocloseconnection&(rd == -1))) {								
								rd = in.read(res);
								if (rd!=-1) {
									bufferout.write(res, 0, rd);
									bytein += rd;
								}
								System.out.println("FTPD : new "+rd+" b");
								//Thread.currentThread().sleep(100);
							}
							tocloseconnection = false;
							in.close();
							mdlet.addLogCommand("FTPD:Downloaded");
							if (ftpl != null) ftpl.actionComplete(ftplres, ftplname);							
						} catch (Exception e) {
							mdlet.addLogCommand("FTPD:Download:"+e);
						}
				}
				closeDataPort();
	        } catch(Exception e) {
	        	mdlet.addLogCommand("FTPD: "+e);
	        	break;
	        }
		}
		System.out.println("FTPD:Quiting from "+thisthread+", dalive="+dalive);
		closeDataPort();
	}

	public void upload(byte[] vv) {
		job = UPLOAD;
		bufferin.write(vv, 0, vv.length);
	}

	public void upload(InputStream s) {
		try {
			byte[] vv = new byte[28502]; s.read(vv);
			System.out.println("FTPD:New resource loaded : "+vv.length);
    	    upload(vv);
    	} catch (Exception e) {
    		mdlet.addLogCommand("FTPD:Resource load failed:"+e);
    	}
	}

	public byte[] download() {
		//job = DOWNLOAD;
		//System.out.println("FTPD.download called :"+((bufferout!=null)?bufferout.size()+"b":"buffer is null"));
		if (bufferout != null) return bufferout.toByteArray();
		return null;
	}
}
