import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.Stack;

/**
 *
 * @author Posirtron
 * @version
 */
public class FTPMDlet extends javax.microedition.midlet.MIDlet implements CommandListener, FTPListener {
    public Command cmdexit = new Command("Exit", Command.BACK, 0);    

    // log
    private Form log = new Form("Log:");
    private StringItem logcaption = new StringItem("Last command:","...");
    private StringItem logreply = new StringItem("Last reply: ","");
    private StringItem logdata = new StringItem("Data state:","...");
    private StringItem loglist = new StringItem("", "");
    private StringItem loglog =new StringItem("Log:","");
    private Command cmdLogClear = new Command("Clear", Command.SCREEN, 1);
    private Command cmdLogCancel = new Command("Cancel", Command.STOP, 1);
    private Command cmdLogBack = new Command("Back", Command.BACK, 0);

    /* For main menu*/
    private String[] menuitems = {"Camera", "Browse local", "Connect", "Settings", "Info","Exit"};
    private String[] items2 = {"Browse server","Disconnect"};
    private Image[] menuimages = new Image[6];
    private Image[] images2 = new Image[2];
    private List mainmenu = null;
    private Command cmdSelect = new Command("Select", Command.ITEM, 0);

    /* info menu */
    private String[] infostrings = {"About","Show log"};
    private Image[] infoimages = new Image[2];
    private List infomenu;

    /* camera */
    private CameraCanvas camc;
    private PreviewCanvas prev;
  
    /* settings */
    private Settings settings;

    /* for ftp */
    private FTPConnection ftpc = null;
    private boolean connected=false;

    /* other gui*/
    private FolderFTP fftp;
    private boolean LISTloaded=false;
    private FolderLocal floc;

    /* gui change */
    //private Displayable last=null;
    private Stack slast=new Stack();
    private Alert mesbox=new Alert("","", null, null);
    private Alert askbox=new Alert("","",null, AlertType.CONFIRMATION);
    private Command cmdYes = new Command("Yes", Command.OK, 0);
    private Command cmdNo = new Command("No", Command.CANCEL, 0);

    private Command cmdBack = new Command("OK", Command.BACK, 0);

	public void addLogCommand(String s) {
		System.out.println("LogCommand : "+s);
		if (s.startsWith("FTPD")) { logdata.setText(s.substring(5)); } else
		logcaption.setText(s+"...");
		//log.setTitle("PW:"+logcaption.getPreferredWidth()+"MW:"+logcaption.getMinimumWidth());
	}
	public void addLogReply(String s) {
		System.out.println("LogReply : "+s);
		logreply.setText(">"+s);
	}
	public void addLogReply(int v) { addLogReply(""+v); }

	public void addLogState(boolean res) {
		loglog.setText(loglog.getText()+((res)?"Done":"Failed"));
	}
	public void addLogState(String s) {
		System.out.println("logState : "+s);
		if (loglist.getText().length() == 0 ) { loglist.setText(loglog.getText()); } else 
		loglist.setText(loglog.getText()+"\n"+loglist.getText());
		loglog.setText(s+"...");
	}

	public void messageBox(String title, String text) {		
		mesbox.setTitle(title);
		mesbox.setString(text);
		mesbox.setType(AlertType.ERROR);
		//mesbox.addCommand(cmdBack);
		//mesbox.removeCommand(cmdYes);
		//mesbox.removeCommand(cmdNo);
		bringToFront(mesbox);
	}
	public void askMessageBox(String title, String text) {
        askbox.setTitle(title);
		askbox.setString(text);
		//askbox.removeCommand(cmdBack);
		//askbox.addCommand(cmdYes);
		//askbox.addCommand(cmdNo);
		//askbox.setType(AlertType.CONFIRMATION);
		bringToFront(askbox);
	}


	public FTPMDlet () {		
    	try {
			menuimages[0] = Image.createImage("/images/camera.png");
			menuimages[1] = Image.createImage("/images/folder.png");
			menuimages[2] = Image.createImage("/images/earth.png");
			menuimages[3] = Image.createImage("/images/gears.png");
            menuimages[4] = Image.createImage("/images/info.png");
            menuimages[5] = Image.createImage("/images/cross.png");
            images2[0] = Image.createImage("/images/folder2.png");
            images2[1] = Image.createImage("/images/earth2.png");        			
			infoimages[0] = menuimages[4];
			infoimages[1] = Image.createImage("/images/log.png");      
		} catch (Exception e) {System.out.println("Images not Loaded!");}
		
		mainmenu = new List("PhotoStorage", List.IMPLICIT, menuitems, menuimages);
		mainmenu.setSelectCommand(cmdSelect);
		mainmenu.addCommand(cmdexit);
		mainmenu.setCommandListener(this);

		//logcaption.setPreferredSize(150, -1);
		//logcaption.setLayout(Item.LAYOUT_LEFT);
		//logreply.setPreferredSize(150, -1);
		//logreply.setLayout(Item.LAYOUT_RIGHT);
	    log.append(logcaption);	    
        log.append(logreply);
	    log.append(logdata);
        log.append(loglog);
        loglog.setLayout(Item.LAYOUT_NEWLINE_AFTER);
        loglist.setLayout(Item.LAYOUT_NEWLINE_BEFORE);
	    log.append(loglist);	    
        log.addCommand(cmdLogBack);
        log.addCommand(cmdLogClear);
		log.addCommand(cmdLogCancel);		
		log.setCommandListener(this);

		mesbox.addCommand(cmdBack);
		mesbox.setTimeout(Alert.FOREVER);
		mesbox.setCommandListener(this);

		askbox.addCommand(cmdYes);
		askbox.addCommand(cmdNo);
		askbox.setTimeout(Alert.FOREVER);
		askbox.setCommandListener(this);
		
        infomenu = new List("Info", List.IMPLICIT, infostrings, infoimages);
        infomenu.addCommand(cmdLogBack);
		infomenu.setCommandListener(this);

		camc = new CameraCanvas(this);
		prev=new PreviewCanvas(this);
		  
		settings = new Settings(this);

		fftp = new FolderFTP(this);
		floc = new FolderLocal(this);
		floc.setData();

        ftpc = new FTPConnection(this);
		ftpc.setFTPListener(this);
	}

    private Display dd; 

    public void startApp() {   
		dd = Display.getDisplay(this);
		dd.setCurrent(mainmenu);
        		
		//ftpc.connect("localhost", "anonymous", "", "ftp");
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
		System.out.println("Exiting");
		settings.save();
		floc.saveData();
		ftpc.disconnect();
        notifyDestroyed();
    }
    
    public void commandAction(Command c, Displayable d) {
        if (c == cmdexit ) destroyApp(false);
        if (d == log) {
        	if (c == cmdLogClear) loglist.setText("");
        	if (c == cmdLogCancel) ftpc.cancel();
        	if (c == cmdLogBack) goBack();
        } else
        if (d == mesbox) {
            //System.out.println(slast.peek().getClass().getName());
        	if (c == cmdBack) goBack();        
        } else
        if (d == askbox) {
        	MessageBoxListener mbl = /*(MessageBoxListener)slast.peek();*/floc;
        	if (c==cmdYes) mbl.commandSelected(MessageBoxListener.C_YES);
        	if (c==cmdNo)  mbl.commandSelected(MessageBoxListener.C_NO);        	
        } else
        if (d == mainmenu) {        	
        	if (c == cmdSelect) {
        		int ii = mainmenu.getSelectedIndex();
        		if (ii == 0) { /* Show camera ! */ camc.start(); bringToFront(camc);} else
        		if (ii == 1) { /* Browse local */ bringToFront(floc);} else
        		if (connected) switch (ii) {   /* Connected */
	        		case 3 : ftpc.disconnect(); break;
	        		case 2 : 
	        			if (!LISTloaded) { ftpc.retrList(); } else {actionComplete(LIST, null); }
	        			break ;
                    case 4 : showSettings(); break;
                    case 5 : dd.setCurrent(infomenu);break;
	        		case 6 : commandAction(cmdexit, mainmenu); break;
        		} else switch(ii) { /* Not connected */
					case 2 : ftpc.connect(settings.addr, settings.user,settings.pass, settings.fld); break;
					case 3 : showSettings(); break;
					case 4 : dd.setCurrent(infomenu);break;
					case 5 : commandAction(cmdexit, mainmenu);break;
        		}         		
        	}
        } else
        if (d == infomenu) {
        	if (c == List.SELECT_COMMAND) switch (infomenu.getSelectedIndex()) {
        		case 0 : showAbout();break;
        		case 1 : showLog(); break;
        	}  else
        	if  (c == cmdLogBack)  {goBack();}
        } else {
        	if (c == cmdLogBack) {goBack();}
        	if (c == cmdBack) {goBack();}
        }
    }

    public void showLog() {
    	bringToFront(log);
    }
    
    private void showAbout() {
    	Image back=null;
    	try { back = Image.createImage("/images/back.png"); } catch (Exception e) {}
    	String out = "Net Status : "+ftpc.getBytesIn()+"/"+ftpc.getBytesOut()+" b in/out\n"+
    		"System capabilities:\nVideo: "+System.getProperty("video.encodings")+
    		"\nSnapshots: "+System.getProperty("video.snapshot.encodings");
    	Alert aa = new Alert("Status",out , back, null);
    	aa.setTimeout(aa.FOREVER);
    	aa.addCommand(cmdBack);
    	dd.setCurrent(aa);
    }

    private void showSettings() {
    	bringToFront(settings);
    }

    public void actionComplete(int action, String fname) {
    	if (action == CONNECT) {
    		connected = true;
    		mainmenu.delete(2);
    		mainmenu.insert(2, items2[1], images2[1]);
    		mainmenu.insert(2, items2[0], images2[0]);
    		//System.out.println("Connected");
    		goBack();
    	}
    	if (action == DISCONNECT) {
	    	connected = false;
	    	mainmenu.delete(2);
	    	mainmenu.delete(2);
	    	mainmenu.insert(2, menuitems[2], menuimages[2]);
    		//System.out.println("Disconnected");
    		addLogState(true);
    		goBack();
    	}
    	if (action == LIST) {
    		fftp.setData(ftpc.getdownloaded());
    		bringToFront(fftp);
    		if (!LISTloaded) addLogState(true);
    		LISTloaded=true;    		
    	}
    	if (action == RETRIVE) {
    		addLogState(true);		
    		if (fname.indexOf(".ht")==-1) {
                floc.putWithExt(fname, ftpc.getdownloaded());
                //bringToFront(floc);
            }
            //goBack();
    	}
    	if (action == STORE) {
    		addLogState(true);
            if (fname.indexOf(".ht")==-1) {
	    		fftp.put(fname);	    		
	    	}
            goBack();
    	}
    }

    /** used in gui to change screens */
    private Displayable popStack() {
    	if (slast.isEmpty()) {return mainmenu;}else return (Displayable)slast.pop();
    }

    public void goBack() {
    	Displayable last=popStack();
    	System.out.println(last.getClass().getName());
    	if ((last==log)|(last.getClass().getName()=="PreviewCanvas")) last=popStack();
        if (last == dd.getCurrent()) last = mainmenu;
    	//System.out.println("Going back to "+last);
    	dd.setCurrent(last);
    }
    public void toMainMenu() {dd.setCurrent(mainmenu);}
    public void bringToFront(Displayable d) {    
    	Displayable cur = dd.getCurrent();
    	if ((cur != prev)&
    		(cur != mesbox)&
    		(cur != askbox)&
    		(cur != log))slast.push(cur);
    	System.out.println("bringToFront("+d+"): visible "+cur);
    	dd.setCurrent(d);
    }

    /** notifies ftpc to work*/
    public void upload(String fname, byte[] data) {
    	ftpc.uploaddata(data, fname);
    }

    public void download(String fname) {
    	ftpc.downloaddata(fname);
    }

    public void storeNew(String fname, byte[] data) {
    	floc.putNew(fname, data);
    	floc.setSelectedIndex(floc.size()-1, true);
    	bringToFront(floc);
    }


    public void view(String image, byte[] data, int state) {
    	prev.setState(state);
    	prev.setData(image, data);
    	bringToFront(prev);
    }

}
