import javax.microedition.lcdui.*;
import java.io.*;
import java.util.Hashtable;

public class FolderLocal extends Folder implements MessageBoxListener {
	private Hashtable images;

	private Command cmdStore = new Command("Send to server", Command.OK, 1);
	private Command cmdView = new Command("View", Command.OK, 0);
	private Command cmdDelete = new Command("Delete", Command.ITEM, 0); 
	private Command cmdRename = new Command("Rename", Command.ITEM, 0);

	public FolderLocal(FTPMDlet mdlet) {
		super(mdlet, "Local folder");
		//addCommand(cmdView);
        addCommand(cmdStore);
        //addCommand(cmdView);
        addCommand(cmdRename);      
        setSelectCommand(cmdView);
        addCommand(cmdDelete);
        images=new Hashtable();
	}


	public void commandAction(Command c, Displayable d) {
		super.commandAction(c,d);
		if ((c==cmdView)|(c==SELECT_COMMAND)) {
			String tt=getSelected();
			mdlet.view(tt, (byte[])images.get(tt), PreviewCanvas.S_EXISTINGIMAGE);
			}
		if (c==cmdDelete) { deleteSelected();}
		if (c==cmdStore) {
			String tt = getSelected();
			mdlet.upload(tt, (byte[])images.get(tt));
		}
		if (c == cmdRename) {
			
		}
	}

	public String getSelected() {return getString(getSelectedIndex()); }

	public void setData() {
		this.deleteAll();
		DataInputStream dd = RMSStorage.loadFiles();
		try {
			int count=dd.readInt();
			//System.out.println("FLOC.setData(): "+count+" images");
			for (int i=0; i<count; i++) {
				String fname = dd.readUTF();
				System.out.println("FLOC.setData(): new file '"+fname+"'");
				int size = dd.readInt();
				//System.out.println("FLOC.setData(): new image :"+size+" b");
				byte[] image= new byte[size];
	            dd.read(image);
	            append(fname, null);
	            images.put(fname, image);
	        }
		 } catch (Exception e) {
		 	System.out.println("FLOC.setData(): "+e);
		 }
	}

	public void saveData() {
		DataOutputStream dd = RMSStorage.getFileOutputStream();
		try {
			dd.writeInt(size());
			for (int i=0; i<size(); i++) {
				String tt=getString(i);
				byte[] image = (byte[])images.get(tt);
				dd.writeUTF(tt);
				dd.writeInt(image.length);
				dd.write(image, 0, image.length);
			}
		} catch (Exception e)	 {
		}
		RMSStorage.saveFiles();
	}

	private int fileExists(String ff) {
		String f1, f2, ext1=null, ext2=null;
		int pos1=ff.lastIndexOf('.'), pos2;
		if (pos1==-1) {f1=ff;} else {
			f1 = ff.substring(0, pos1);
			ext1 = ff.substring(pos1+1);
		}
		//System.out.println("FolderLocal.fileExists(): f1="+f1+" ext1="+ext1);
		for (int i=0; i<size(); i++) {
			String ff2=getString(i);
			pos2=ff2.lastIndexOf('.');
			//System.out.println("pos2="+pos2);
			if (pos2==-1) {f2=ff2;ext2="";} else {
				f2 = ff2.substring(0, pos2);
				ext2 = ff2.substring(pos2+1);
			} 
            //System.out.println("FolderLocal.fileExists(): comparing with f2="+f2+" ext2="+ext2);
			if ((f1.equals(f2))) {
				System.out.println("FolderLocal.fileExists("+ff+") : File already exists!");
				return i;
			}
		}		
		return -1;
	}

	public void putNew(String fname, byte[] data) {
		int ind=0;
		String tfname=fname;
		while (fileExists(fname) != -1) {
			ind++;
			fname=tfname+"_"+ind;
		}; 
		append(fname+Settings.getExt(), null);
		images.put(fname+Settings.getExt(), data);
	}

	String tfname; byte[] tdata; int ti;

	public void putWithExt(String fname, byte[] data) {
		tfname=fname;
		tdata=data;		
		if ((ti=fileExists(fname))!=-1) {
			mdlet.askMessageBox(fname, "File '"+fname+"' already exists.\nReplace?");
			return;
			}
		append(tfname, null);
		images.put(tfname, tdata);
		mdlet.bringToFront(this);
	}

	public void commandSelected(int cmd) {
		if (cmd==C_YES) {
			set(ti, tfname, null);
			images.put(tfname, tdata);
		}
		mdlet.bringToFront(this);
	}


	public void delete(int index) {		
		images.remove(getString(index));
        super.delete(index);
	}
	public void deleteSelected() {delete(getSelectedIndex());}

}
