import javax.microedition.lcdui.*;

public class PreviewCanvas extends Canvas implements CommandListener{
	private FTPMDlet mdlet;
	private Image image;
	private byte[] dd;
	private String fname;
	private Command cmdSave = new Command("Save", Command.OK, 0);
	private Command cmdStore = new Command("Upload to server", Command.OK, 1);
	private Command cmdCancel = new Command("Back", Command.BACK, 0);

	private Font font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_MEDIUM );

	public static final int
		S_NEWIMAGE=1,
		S_EXISTINGIMAGE=2;
	//	S_REMOTEIMAGE=3;

	private int state=S_NEWIMAGE;	


	public PreviewCanvas(FTPMDlet mdlet) {
		this.mdlet = mdlet;

		addCommand(cmdSave);
		addCommand(cmdStore);
		addCommand(cmdCancel);

		setCommandListener(this);
	}

	public void setData(String fname, byte[] dd) {
		this.dd=dd;
		this.fname=fname;
		image = Image.createImage(dd, 0, dd.length);
		if (image == null) {} 
	}
	
	public void paint(Graphics g) {
		g.setColor(0);
		g.fillRect(0,0, getWidth(), getHeight());		
		g.setColor(0xFFFFFF);
		g.setFont(font);
		g.drawString(fname, getWidth()/2, 3, Graphics.TOP|Graphics.HCENTER);
        
		if (image != null) {
			g.drawRect(0, 20, image.getWidth()+2, 122);
			g.drawImage(image, 1, 21, Graphics.TOP|Graphics.LEFT);
			} else {
			g.setColor(0xFF0000);
			g.setFont(font);
			g.drawString("The image cannot be displayed!\nEither your phone doesn't support JPEG or Camera doesn't follow MIDP rules", 10,10, Graphics.TOP|Graphics.HCENTER);
		}
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSave) { /* save picture in rms */
			mdlet.storeNew(fname, dd);
			} else
		if (c == cmdStore) { /* upload */ mdlet.upload(fname+Settings.getExt(), dd); } else 
		if (c == cmdCancel) { mdlet.goBack();}
	}

	public void setState(int state) {
		if (this.state==state) return;
		this.state=state;
		switch (state) {
		   case S_NEWIMAGE : addCommand(cmdSave) ; break;
		   case S_EXISTINGIMAGE : removeCommand(cmdSave); break;
		}
	}


}