import javax.microedition.lcdui.*;
import javax.microedition.midlet.*; 

public class Settings extends Form implements CommandListener {
	private FTPMDlet mdlet;

	private TextField fip = new TextField("Address:","", 125, TextField.URL);
	private TextField fuser = new TextField("User name:","", 30, TextField.ANY | TextField.NON_PREDICTIVE);
	private TextField fpass = new TextField("Password:", "", 30, TextField.PASSWORD);
	private TextField ffolder = new TextField("Server folder:", "",30, TextField.URL);

	private Command cmdOk = new Command("OK", Command.OK, 0);
	private Command cmdcancel = new Command("Cancel", Command.BACK, 0);

	public String addr, user, pass, fld;

	public Settings(FTPMDlet mdlet) {
		super ("Settings");
		this.mdlet  = mdlet;
		/*addr = "localhost";
		user = "anonymous";
		pass = "";
		fld = "ftp";
		  */
		RMSStorage.loadSettings();
		addr = RMSStorage.getAddr();
        user = RMSStorage.getUser();
        pass = RMSStorage.getPass();
        fld = RMSStorage.getFld();

		fip.setInitialInputMode("MIDP_LOWERCASE_LATIN");
        fip.setString(addr);         
		fuser.setInitialInputMode("MIDP_LOWERCASE_LATIN");		
		fuser.setString(user);
        ffolder.setInitialInputMode("MIDP_LOWERCASE_LATIN");  
        ffolder.setString(fld);
        fpass.setInitialInputMode("MIDP_LOWERCASE_LATIN");
        fpass.setString(pass);
         
        append(fip);
        append(fuser);
        append(fpass);
        append(ffolder);

        addCommand(cmdOk);
        addCommand(cmdcancel);
        setCommandListener(this);        
	}

	public void save() {
		RMSStorage.saveSettings(addr, user, pass, fld);
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdOk)	 {
			addr = fip.getString();
			user = fuser.getString();
			fld = ffolder.getString();
			pass = fpass.getString();
			mdlet.goBack();
		}
		if (c == cmdcancel)  {
			fip.setString(addr);
			fuser.setString(user);
			ffolder.setString(fld);
			fpass.setString(pass);
			mdlet.goBack();
		}

	}

	static private String ext="jyh";

	static public String getExt() {
		if (ext.equals("jyh")) {
			String enc=System.getProperty("video.snapshot.encodings").toLowerCase();
			if (enc.indexOf("jp") != -1) { ext= ".jpg";} else {	ext=".png";}
		}
		return ext;
	}

	
}